Subject: Re: bug#33140: 27.0.50; `gnus-posting-styles' sees nil‘message-reply-headers’ variable

From: "N. Jackson" <[email-masked]>
Date: Thu, 06 Dec 2018 20:57:05 -0500

At 12:54 -0800 on Wednesday 2018-12-05, Eric Abrahamsen wrote:

> "N. Jackson" <[email-masked]> writes:
>
>> I'm trying to set up a Gnus posting style that makes use of the
>> ‘message-reply-headers’ variable, but the behaviour I see indicates that
>> this variable is always nil (in the context where the posting styles are
>> evaluated).
>>
>> It seems (this is a wild guess) that the function
>> `gnus-configure-posting-styles' that applies the posting styles that
>> match, and which is called from `message-mode-hook' (I believe), is
>> called before `message-reply-headers' is set.
>>
>> Either that, or `gnus-configure-posting-styles' is evaluated in the
>> context of the wrong buffer (`message-reply-headers' is buffer local to
>> the *unsent reply...* buffer).
>
> So far as I can tell, the problem is the former --
> `gnus-configure-posting-styles' is called before `message-reply-headers'
> is set.
>
> Both `message-reply' and `message-followup' first call
> `message-pop-to-buffer' (which ends up calling `message-mode' and thus
> the `message-mode-hooks', and thus `gnus-configure-posting-styles').
>
> Then they set `message-reply-headers'.
>
> Then they call `message-setup', which calls `message-setup-1', which
> runs the `message-setup-hook', which would be a spot where
> `message-reply-headers' would be accessible.
>
> I will check and see if this changed sometime recently.

I haven't been able to convince myself that `message-reply-headers' can
ever have worked properly with Gnus posting styles. 

> I would say that posting-style configuration could be moved to the
> `message-setup-hook',

That sounds right, I think. 

> except that that would be guaranteed to wreck all manner of existing
> configurations and get us lots of angry emails.

Maybe. I haven't been able to think of how it would negatively affect
existing setups, but probably I'm just lacking in imagination!